package jalview.gui;

import jalview.datamodel.*;
import jalview.jbgui.GPairwiseAlignPanel;
import jalview.analysis.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;


public class PairwiseAlignPanel extends GPairwiseAlignPanel
{
    Vector sequences = new Vector();
    AlignViewport av;

    public PairwiseAlignPanel(AlignViewport av)
    {
      super();
      this.av = av;
      Vector selsubset = new Vector();
      for (int i=0, j=av.getSelectionGroup().getSize(); i<j; i++)
        if (av.getAlignment().getSequences().contains(av.getSelectionGroup().getSequenceAt(i)))
          selsubset.add(av.getSelectionGroup().getSequenceAt(i));
      float scores[][] = new float[selsubset.size()][selsubset.size()];
      double totscore = 0;
      int count = selsubset.size();

      int acount = 0;
      for (int i = 1; i < count; i++)
      {
        for (int j = 0; j < i; j++)
        {
          acount++;
          AlignSeq as = new AlignSeq( (SequenceI) selsubset.elementAt(i),
                                     (SequenceI) selsubset.elementAt(j), "pep");
          as.calcScoreMatrix();
          as.traceAlignment();
          as.printAlignment();
          scores[i][j] = (float) as.getMaxScore() /
              (float) as.getASeq1().length;
          totscore = totscore + scores[i][j];

          textarea.append(as.getOutput());
          sequences.add(new Sequence(as.getS1().getName(), as.getAStr1()));
          sequences.add(new Sequence(as.getS2().getName(), as.getAStr2()));
        }
      }
      if (count > 2)
      {
        System.out.println("Pairwise alignment scaled similarity score matrix\n");
        for (int i = 0; i < count;i++)
          jalview.util.Format.print(System.out, "%s \n", (""+i)+" "+((SequenceI) selsubset.elementAt(i)).getName());
        System.out.println("\n");
        for (int i = 0; i < count;i++)
          for (int j = 0; j < i; j++)
            jalview.util.Format.print(System.out,"%7.3f",scores[i][j]/totscore);
        System.out.println("\n");

      }
    }


  protected void viewInEditorButton_actionPerformed(ActionEvent e)
  {

      Sequence [] seq = new Sequence[sequences.size()];

      for (int i=0;i<sequences.size();i++)
       seq[i] = (Sequence) sequences.elementAt(i);


      AlignFrame af = new AlignFrame(new Alignment(seq));
      Desktop.addInternalFrame(af, "Pairwise Aligned Sequences",
                               AlignFrame.NEW_WINDOW_WIDTH,
                               AlignFrame.NEW_WINDOW_HEIGHT);

  }

}
